package nc.impl.lwcw.oa;

package ..deTemp.1750919692247;

import java.io.ByteArrayInputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.lwcw.itf.oa.IOAService;
import nc.lwcw.pub.BaseDaoUtil;
import nc.lwcw.pub.FreeMakerUtil;
import nc.lwcw.pub.RestTemplateUtil;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class OAServiceImpl implements IOAService {
  public String voucherAdd(String xml) throws Exception {
    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
    DocumentBuilder builder = factory.newDocumentBuilder();
    ByteArrayInputStream input = new ByteArrayInputStream(xml.getBytes("gb2312"));
    Document doc = builder.parse(input);
    Element ufinterface = doc.getDocumentElement();
    NodeList voucherList = doc.getElementsByTagName("voucher");
    Element voucher = (Element)voucherList.item(0);
    NodeList voucherHeadList = doc.getElementsByTagName("voucher_head");
    Element voucherHead = (Element)voucherHeadList.item(0);
    Map<String, Object> rootMap = new HashMap<>(16);
    rootMap.put("id", voucher.getAttribute("id"));
    rootMap.put("pk_org", getElementValue(voucherHead, "company"));
    rootMap.put("pk_vouchertype", BaseDaoUtil.columnResult(new String[] { "select code from bd_vouchertype where name = '" + getElementValue(voucherHead, "voucher_type") + "' and isnull(dr, 0) = 0" }));
    rootMap.put("pk_group", "LW");
    rootMap.put("receiver", ufinterface.getAttribute("receiver"));
    rootMap.put("sender", ufinterface.getAttribute("sender"));
    rootMap.put("pk_system", "gl");
    String pk_accountingbook = BaseDaoUtil.columnResult(new String[] { " select a.code  from org_accountingbook a  left join org_setofbook b on b.pk_setofbook = a.pk_setofbook and isnull(b.dr, 0) = 0  left join org_financeorg c on c.pk_financeorg = a.pk_relorg and c.enablestate = '2' and isnull(c.dr, 0) = 0  where isnull(a.dr, 0) = 0 and a.enablestate = '2'  and c.code = '" + getElementValue(voucherHead, "company") + "'  and a.pk_group = '" + 
          InvocationInfoProxy.getInstance().getGroupId() + "'  and b.code = '0001'" });
    rootMap.put("pk_accountingbook", pk_accountingbook);
    rootMap.put("period", getElementValue(voucherHead, "accounting_period"));
    rootMap.put("year", getElementValue(voucherHead, "fiscal_year"));
    rootMap.put("prepareddate", getElementValue(voucherHead, "prepareddate"));
    rootMap.put("preparedid", "OA");
    List<Map<String, Object>> detailList = new ArrayList<>();
    NodeList voucherBodyList = doc.getElementsByTagName("voucher_body");
    Element voucherBody = (Element)voucherBodyList.item(0);
    NodeList entryNodes = voucherBody.getElementsByTagName("entry");
    for (int i = 0; i < entryNodes.getLength(); i++) {
      Element itemEntry = (Element)entryNodes.item(i);
      Map<String, Object> detailMap = new HashMap<>(16);
      detailMap.put("explanation", getElementValue(itemEntry, "abstract"));
      detailMap.put("debitamount", Double.valueOf(Double.parseDouble(getElementValue(itemEntry, "primary_debit_amount"))));
      detailMap.put("localdebitamount", Double.valueOf(Double.parseDouble(getElementValue(itemEntry, "natural_debit_currency"))));
      detailMap.put("creditamount", Double.valueOf(Double.parseDouble(getElementValue(itemEntry, "primary_credit_amount"))));
      detailMap.put("localcreditamount", Double.valueOf(Double.parseDouble(getElementValue(itemEntry, "natural_credit_currency"))));
      detailMap.put("pk_currtype", "CNY");
      detailMap.put("pk_accasoa", getElementValue(itemEntry, "account_code"));
      detailMap.put("free2", getElementValue(itemEntry, "free2"));
      detailMap.put("free6", getElementValue(itemEntry, "free6"));
      List<Map<String, Object>> assList = new ArrayList<>();
      Element auxiliaryAccounting = (Element)itemEntry.getElementsByTagName("auxiliary_accounting").item(0);
      NodeList items = auxiliaryAccounting.getElementsByTagName("item");
      for (int j = 0; j < items.getLength(); j++) {
        Element item = (Element)items.item(j);
        Map<String, Object> assMap = new HashMap<>(16);
        String deptcode = " select bd_defdoc.code from bd_defdoc,bd_defdoclist where bd_defdoclist.pk_defdoclist = bd_defdoc.pk_defdoclist and isnull(bd_defdoc.dr, 0) = 0  and isnull(bd_defdoclist.dr, 0) = 0 and bd_defdoc.enablestate = '2' and bd_defdoclist.code = 'LW_0015' and bd_defdoc.name = '" + 
          item.getAttribute("name") + "'";
        assMap.put("pk_checktype", BaseDaoUtil.columnResult(new String[] { deptcode }));
        assMap.put("pk_checkvalue", item.getTextContent());
        assList.add(assMap);
      } 
      detailMap.put("assList", assList);
      detailList.add(detailMap);
    } 
    rootMap.put("detailList", detailList);
    xml = FreeMakerUtil.getInstance().loadTemplate("voucher.xml", rootMap);
    return RestTemplateUtil.postXML(BaseDaoUtil.getExtSysItfConfig("jhpturl"), xml);
  }
  
  private String getElementValue(Element parent, String tagName) {
    NodeList nodeList = parent.getElementsByTagName(tagName);
    if (nodeList != null && nodeList.getLength() > 0) {
      Element element = (Element)nodeList.item(0);
      if (element.getFirstChild() != null)
        return element.getFirstChild().getNodeValue(); 
    } 
    return "";
  }
}
